%define anolis_release 6
%global _hardened_build 1
%global sysconfig_anaconda /etc/sysconfig/sshd-permitrootlogin

%bcond_without libfido2
%bcond_without libedit
%bcond_without pam

Name:    openssh
Version: 9.0p1
Release: %{anolis_release}%{?dist}
Summary: An open source implementation of SSH protocol version 2
License: BSD
URL:     http://www.openssh.com/portable.html
Source0: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz
Source1: https://github.com/jbeverly/pam_ssh_agent_auth/archive/pam_ssh_agent_auth-0.10.4.tar.gz
Source2: sshd.pam
Source3: pam_ssh_agent-rmheaders
Source4: ssh-keycat.pam
Source5: sshd.sysconfig
Source6: sshd@.service
Source7: sshd.socket
Source8: sshd.service
Source9: sshd-keygen@.service
Source10: sshd-keygen
Source11: sshd-keygen.target
Source12: ssh-agent.service
Source13: ssh-agent.socket
Source14: openssh-server-systemd-sysusers.conf

# --- patches for pam_ssh-agent ---
Patch100: pam_ssh_agent_auth-0.9.3-build.patch
Patch101: pam_ssh_agent_auth-0.10.3-seteuid.patch
Patch102: pam_ssh_agent_auth-0.9.2-visibility.patch
Patch103: pam_ssh_agent_auth-0.10.2-compat.patch
Patch104: pam_ssh_agent_auth-0.9.3-agent_structure.patch
Patch105: pam_ssh_agent_auth-0.10.2-dereference.patch
Patch106: pam_ssh_agent_auth-0.10.4-rsasha2.patch

Patch300: openssh-7.8p1-role-mls.patch
Patch301: openssh-6.6p1-privsep-selinux.patch
Patch302: openssh-6.6p1-keycat.patch
Patch303: openssh-6.6p1-allow-ip-opts.patch
Patch304: openssh-5.8p2-sigpipe.patch
Patch305: openssh-7.2p2-x11.patch
Patch306: openssh-5.1p1-askpass-progress.patch
Patch307: openssh-4.3p2-askpass-grab-info.patch
Patch308: openssh-7.7p1-anolis.patch
Patch309: openssh-7.8p1-UsePAM-warning.patch
Patch310: openssh-6.3p1-ctr-evp-fast.patch
Patch311: openssh-8.0p1-gssapi-keyex.patch
Patch312: openssh-6.6p1-force_krb.patch
Patch313: openssh-7.7p1-gssapi-new-unique.patch
Patch314: openssh-7.2p2-k5login_directory.patch
Patch315: openssh-6.6p1-kuserok.patch
Patch316: openssh-6.4p1-fromto-remote.patch
Patch317: openssh-6.6.1p1-selinux-contexts.patch
Patch318: openssh-6.6.1p1-log-in-chroot.patch
Patch319: openssh-6.6.1p1-scp-non-existing-directory.patch
Patch320: openssh-6.6p1-GSSAPIEnablek5users.patch
Patch321: openssh-6.8p1-sshdT-output.patch
Patch322: openssh-6.7p1-sftp-force-permission.patch
Patch323: openssh-7.3p1-x11-max-displays.patch
Patch324: openssh-7.4p1-systemd.patch
Patch325: openssh-7.6p1-cleanup-selinux.patch
Patch326: openssh-7.5p1-sandbox.patch
Patch327: openssh-8.0p1-pkcs11-uri.patch
Patch328: openssh-7.8p1-scp-ipv6.patch
Patch329: openssh-8.0p1-crypto-policies.patch
Patch330: openssh-8.0p1-openssl-evp.patch
Patch331: openssh-8.0p1-openssl-kdf.patch
Patch332: openssh-8.2p1-visibility.patch
Patch333: openssh-8.2p1-x11-without-ipv6.patch
Patch334: openssh-8.0p1-keygen-strip-doseol.patch
Patch335: openssh-8.0p1-preserve-pam-errors.patch
Patch336: openssh-8.7p1-scp-kill-switch.patch
Patch337: openssh-8.7p1-recursive-scp.patch
Patch338: openssh-8.7p1-minrsabits.patch
Patch339: openssh-8.7p1-evpgenkey.patch
Patch340: openssh-7.6p1-audit.patch
Patch341: openssh-7.1p2-audit-race-condition.patch
Patch342: openssh-7.7p1-fips.patch
Patch343: openssh-8.7p1-scp-clears-file.patch
Patch344: openssh-8.7p1-ssh-manpage.patch
Patch345: openssh-8.7p1-mem-leak.patch
Patch346: openssh-8.7p1-gssapi-auth.patch
Patch347: openssh-8.7p1-negotiate-supported-algs.patch
Patch348: openssh-6.7p1-coverity.patch

BuildRequires: autoconf automake make gcc
BuildRequires: perl-interpreter perl-generators perl-podlators
BuildRequires: zlib-devel libX11-devel gtk3-devel pam-devel p11-kit-devel krb5-devel
BuildRequires: audit-libs-devel >= 2.0.5 openssl-devel >= 0.9.8j
BuildRequires: libselinux-devel >= 2.3-5 audit-libs >= 1.0.8
BuildRequires: util-linux groff xauth
BuildRequires: systemd-devel systemd-rpm-macros
%if %{with libfido2}
BuildRequires: libfido2-devel
%endif
%if %{with libedit}
BuildRequires: libedit-devel ncurses-devel
%endif

Recommends: p11-kit

Requires: /sbin/nologin
Requires: libselinux >= 2.3-5 audit-libs >= 1.0.8
Obsoletes: openssh-ldap < 8.3p1-4
Obsoletes: openssh-cavs < 8.4p1-5

%description
SSH (Secure SHell) is a program for logging into and executing
commands on a remote machine. SSH is intended to replace rlogin and
rsh, and to provide secure encrypted communications between two
untrusted hosts over an insecure network. X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's version of the last free version of SSH, bringing
it up to date in terms of security and features.

This package includes the core files necessary for both the OpenSSH
client and server. To make this package useful, you should also
install openssh-clients, openssh-server, or both.

%package clients
Summary: An open source SSH client applications
Requires: openssh = %{EVR}
Requires: crypto-policies >= 20220824-1

%description clients
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package includes
the clients necessary to make encrypted connections to SSH servers.

%package server
Summary: An open source SSH server daemon
Requires: openssh = %{EVR}
Requires(pre): /usr/sbin/useradd
Requires: pam >= 1.0.1-3 crypto-policies >= 20220824-1
%{?systemd_requires}

%description server
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package contains
the secure shell daemon (sshd). The sshd daemon allows SSH clients to
securely connect to your SSH server.

%package keycat
Summary: A mls keycat backend for openssh
Requires: openssh = %{EVR}

%description keycat
OpenSSH mls keycat is backend for using the authorized keys in the
openssh in the mls mode.

%package askpass
Summary: A passphrase dialog for OpenSSH and X
Requires: openssh = %{EVR}

%description askpass
OpenSSH is a free version of SSH (Secure SHell), a program for logging
into and executing commands on a remote machine. This package contains
an X11 passphrase dialog for OpenSSH.

%package doc
Summary:        Documentation files for %{name}
Requires:       openssh = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package -n pam_ssh_agent_auth
Summary: PAM module for authentication with ssh-agent
Version: 0.10.4
Release: 7.%{anolis_release}%{?dist}
License: BSD

%description -n pam_ssh_agent_auth
This package contains a PAM module which can be used to authenticate
users using ssh keys stored in a ssh-agent. Through the use of the
forwarding of ssh-agent connection it also allows to authenticate with
remote ssh-agent instance.

The module is most useful for su and sudo service stacks.

%prep
%setup -q -a 1

%if %{with pam}
pushd pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4
%autopatch -M 200 -p2
rm -f $(cat %{SOURCE3})
popd
%endif

%autopatch -m 200 -p1

autoreconf
pushd pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4
autoreconf
popd

%build
%set_build_flags
# the -fvisibility=hidden is needed for clean build of the pam_ssh_agent_auth
# it is needed for lib(open)ssh build too since it is linked to the pam module too
CFLAGS="$CFLAGS -fvisibility=hidden -fpic"; export CFLAGS
SAVE_LDFLAGS="$LDFLAGS"
LDFLAGS="$LDFLAGS -pie -z relro -z now"; export LDFLAGS

if test -r /etc/profile.d/krb5-devel.sh ; then
	source /etc/profile.d/krb5-devel.sh
fi
krb5_prefix=`krb5-config --prefix`
if test "$krb5_prefix" != "%{_prefix}" ; then
	CPPFLAGS="$CPPFLAGS -I${krb5_prefix}/include -I${krb5_prefix}/include/gssapi"; export CPPFLAGS
	CFLAGS="$CFLAGS -I${krb5_prefix}/include -I${krb5_prefix}/include/gssapi"
	LDFLAGS="$LDFLAGS -L${krb5_prefix}/%{_lib}"; export LDFLAGS
else
	krb5_prefix=
	CPPFLAGS="-I%{_includedir}/gssapi"; export CPPFLAGS
	CFLAGS="$CFLAGS -I%{_includedir}/gssapi"
fi

%configure \
	--sysconfdir=%{_sysconfdir}/ssh \
	--libexecdir=%{_libexecdir}/openssh \
	--datadir=%{_datadir}/openssh \
	--with-default-path=/usr/local/bin:/usr/bin:/usr/local/sbin:/usr/sbin \
	--with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin \
	--with-privsep-path=%{_datadir}/empty.sshd \
	--disable-strip \
	--without-zlib-version-check \
	--with-ssl-engine \
	--with-ipaddr-display \
	--with-pie=no \
	--without-hardening  \
	--with-systemd \
	--with-default-pkcs11-provider=yes \
%if %{with libfido2}
        --enable-security-key \
%else
        --disable-security-key \
%endif
	--with-security-key-builtin=yes \
	--with-pam \
	--with-selinux --with-audit=linux \
	--with-sandbox=seccomp_filter \
	--with-kerberos5${krb5_prefix:+=${krb5_prefix}} \
%if %{with libedit}
	--with-libedit
%else
	--without-libedit
%endif


%make_build

pushd contrib
CFLAGS="$CFLAGS %{?__global_ldflags}" make gnome-ssh-askpass3
mv gnome-ssh-askpass3 gnome-ssh-askpass
popd

%if %{with pam}
pushd pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4
LDFLAGS="$SAVE_LDFLAGS"
%configure --with-selinux \
	--libexecdir=/%{_libdir}/security \
	--with-mantype=man \
	--without-openssl-header-check
%make_build
popd
%endif

%check
%if %{?_with_check:1}%{!?_with_check:0}
make tests
%endif

%install
mkdir -p -m755 %{buildroot}%{_sysconfdir}/ssh
mkdir -p -m755 %{buildroot}%{_sysconfdir}/ssh/ssh_config.d
mkdir -p -m755 %{buildroot}%{_sysconfdir}/ssh/sshd_config.d
mkdir -p -m755 %{buildroot}%{_libexecdir}/openssh
%make_install

install -d %{buildroot}/etc/pam.d/
install -d %{buildroot}/etc/sysconfig/
install -d %{buildroot}%{_libexecdir}/openssh
install -m644 %{SOURCE2} %{buildroot}/etc/pam.d/sshd
install -m644 %{SOURCE4} %{buildroot}/etc/pam.d/ssh-keycat
install -m644 %{SOURCE5} %{buildroot}/etc/sysconfig/sshd
install -m644 ssh_config_anolis %{buildroot}/etc/ssh/ssh_config.d/50-anolis.conf
install -m644 sshd_config_anolis %{buildroot}/etc/ssh/sshd_config.d/50-anolis.conf
install -d -m755 %{buildroot}/%{_unitdir}
install -m644 %{SOURCE6} %{buildroot}/%{_unitdir}/sshd@.service
install -m644 %{SOURCE7} %{buildroot}/%{_unitdir}/sshd.socket
install -m644 %{SOURCE8} %{buildroot}/%{_unitdir}/sshd.service
install -m644 %{SOURCE9} %{buildroot}/%{_unitdir}/sshd-keygen@.service
install -m644 %{SOURCE11} %{buildroot}/%{_unitdir}/sshd-keygen.target
install -d -m755 %{buildroot}/%{_userunitdir}
install -m644 %{SOURCE12} %{buildroot}/%{_userunitdir}/ssh-agent.service
install -m644 %{SOURCE13} %{buildroot}/%{_userunitdir}/ssh-agent.socket
install -m744 %{SOURCE10} %{buildroot}/%{_libexecdir}/openssh/sshd-keygen
install -m755 contrib/ssh-copy-id %{buildroot}%{_bindir}/
install contrib/ssh-copy-id.1 %{buildroot}%{_mandir}/man1/
install -d -m711 ${RPM_BUILD_ROOT}/%{_datadir}/empty.sshd
install -p -D -m 0644 %{SOURCE14} %{buildroot}%{_sysusersdir}/openssh-server.conf

install -m755 contrib/gnome-ssh-askpass %{buildroot}%{_libexecdir}/openssh/gnome-ssh-askpass

ln -s gnome-ssh-askpass %{buildroot}%{_libexecdir}/openssh/ssh-askpass
install -m 755 -d %{buildroot}%{_sysconfdir}/profile.d/
install -m 755 contrib/redhat/gnome-ssh-askpass.csh %{buildroot}%{_sysconfdir}/profile.d/
install -m 755 contrib/redhat/gnome-ssh-askpass.sh %{buildroot}%{_sysconfdir}/profile.d/

perl -pi -e "s|%{buildroot}||g" %{buildroot}%{_mandir}/man*/*

%if %{with pam}
pushd pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4
%make_install
popd
%endif

%generate_compatibility_deps

%pre server
%sysusers_create_compat %{SOURCE14}
# We want to remove group ownership for standard host keys if they exist
test -f /etc/ssh/ssh_host_rsa_key     && /usr/bin/chmod g-r /etc/ssh/ssh_host_rsa_key     || :
test -f /etc/ssh/ssh_host_ecdsa_key   && /usr/bin/chmod g-r /etc/ssh/ssh_host_ecdsa_key   || :
test -f /etc/ssh/ssh_host_ed25519_key && /usr/bin/chmod g-r /etc/ssh/ssh_host_ed25519_key || :

%post server
%systemd_post sshd.service sshd.socket
test -f %{sysconfig_anaconda} && \
  test ! -f /etc/ssh/sshd_config.d/01-permitrootlogin.conf && \
  grep -q '^PERMITROOTLOGIN="-oPermitRootLogin=yes"' %{sysconfig_anaconda} && \
  grep -q '^Include /etc/ssh/sshd_config.d/\*.conf' /etc/ssh/sshd_config && \
  echo "PermitRootLogin yes" >> /etc/ssh/sshd_config.d/25-permitrootlogin.conf && \
  rm %{sysconfig_anaconda} || :

%preun server
%systemd_preun sshd.service sshd.socket

%postun server
%systemd_postun_with_restart sshd.service

%post clients
%systemd_user_post ssh-agent.service
%systemd_user_post ssh-agent.socket

%preun clients
%systemd_user_preun ssh-agent.service
%systemd_user_preun ssh-agent.socket

%files
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ssh/moduli
%attr(0755,root,root) %dir %{_sysconfdir}/ssh
%attr(0755,root,root) %{_bindir}/ssh-keygen
%attr(0755,root,root) %dir %{_libexecdir}/openssh
%attr(4555,root,root) %{_libexecdir}/openssh/ssh-keysign

%attr(0644,root,root) %{_mandir}/man1/ssh-keygen.1*
%attr(0644,root,root) %{_mandir}/man8/ssh-keysign.8*
%license LICENCE

%files clients
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ssh/ssh_config
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/ssh/ssh_config.d/50-anolis.conf
%dir %attr(0755,root,root) %{_sysconfdir}/ssh/ssh_config.d/

%attr(0755,root,root) %{_bindir}/ssh
%attr(0755,root,root) %{_bindir}/scp
%attr(0755,root,root) %{_bindir}/ssh-agent
%attr(0755,root,root) %{_bindir}/ssh-add
%attr(0755,root,root) %{_bindir}/ssh-keyscan
%attr(0755,root,root) %{_bindir}/sftp
%attr(0755,root,root) %{_bindir}/ssh-copy-id
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-pkcs11-helper
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-sk-helper
%attr(0644,root,root) %{_userunitdir}/ssh-agent.service
%attr(0644,root,root) %{_userunitdir}/ssh-agent.socket

%attr(0644,root,root) %{_mandir}/man1/ssh.1*
%attr(0644,root,root) %{_mandir}/man1/scp.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-agent.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-add.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keyscan.1*
%attr(0644,root,root) %{_mandir}/man1/sftp.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-copy-id.1*
%attr(0644,root,root) %{_mandir}/man5/ssh_config.5*
%attr(0644,root,root) %{_mandir}/man8/ssh-pkcs11-helper.8*
%attr(0644,root,root) %{_mandir}/man8/ssh-sk-helper.8*

%files server
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/ssh/sshd_config
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/ssh/sshd_config.d/50-anolis.conf
%attr(0644,root,root) %config(noreplace) /etc/pam.d/sshd
%attr(0640,root,root) %config(noreplace) /etc/sysconfig/sshd
%dir %attr(0700,root,root) %{_sysconfdir}/ssh/sshd_config.d/
%attr(0644,root,root) %{_sysusersdir}/openssh-server.conf

%attr(0755,root,root) %{_sbindir}/sshd
%attr(0755,root,root) %{_libexecdir}/openssh/sftp-server
%attr(0755,root,root) %{_libexecdir}/openssh/sshd-keygen

%attr(0644,root,root) %{_unitdir}/sshd.service
%attr(0644,root,root) %{_unitdir}/sshd@.service
%attr(0644,root,root) %{_unitdir}/sshd.socket
%attr(0644,root,root) %{_unitdir}/sshd-keygen@.service
%attr(0644,root,root) %{_unitdir}/sshd-keygen.target
%dir %attr(0711,root,root) %{_datadir}/empty.sshd

%attr(0644,root,root) %{_mandir}/man5/sshd_config.5*
%attr(0644,root,root) %{_mandir}/man5/moduli.5*
%attr(0644,root,root) %{_mandir}/man8/sshd.8*
%attr(0644,root,root) %{_mandir}/man8/sftp-server.8*

%files keycat
%attr(0644,root,root) %config(noreplace) /etc/pam.d/ssh-keycat
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-keycat
%doc HOWTO.ssh-keycat

%files askpass
%attr(0644,root,root) %{_sysconfdir}/profile.d/gnome-ssh-askpass.*
%attr(0755,root,root) %{_libexecdir}/openssh/gnome-ssh-askpass
%attr(0755,root,root) %{_libexecdir}/openssh/ssh-askpass

%if %{with pam}
%files -n pam_ssh_agent_auth
%license pam_ssh_agent_auth-pam_ssh_agent_auth-0.10.4/OPENSSH_LICENSE
%attr(0755,root,root) %{_libdir}/security/pam_ssh_agent_auth.so
%attr(0644,root,root) %{_mandir}/man8/pam_ssh_agent_auth.8*
%dir %{abidir}
%attr(0644,root,rooti) %{abidir}/pam_ssh_agent_auth.dump
%endif

%files doc
%doc README*
%doc CREDITS ChangeLog OVERVIEW PROTOCOL*  TODO

%changelog
* Wed Apr 19 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 9.0p1-6
- Remove several irrelevant patches

* Wed Apr 12 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 9.0p1-5
- Refactor the specfile

* Fri Mar 31 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 9.0p1-4
- Del Specific Fields

* Mon Feb 20 2023 Funda Wang <fundawang@yeah.net> - 9.0p1-3
- Enable libfido2 support
- bugfix the ssh_keys not exist in /etc/group

* Fri Feb 17 2023 Funda Wang <fundawang@yeah.net> - 9.0p1-2
- Add switch for libfido2 support
 
* Thu Feb 02 2023 happy_orange <songnannan@linux.alibaba.com> - 9.0p1-1
- update to 9.0p1

* Thu Feb 02 2023 happy_orange <songnannan@linux.alibaba.com> - 8.8p1-4
- add patches from upstream

* Tue Oct 18 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.8p1-3
- optimise spec file & add doc package

* Mon Aug 29 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.8p1-2
- Use gtk3 intead of gtk2
- add openssh-server and openssh-clients as Requires for openssh-askpass to make sure update

* Fri Mar 11 2022 zhang xianting <zhangxianting@uniontech.com> - 8.8p1-1
- Initial build for Anolis v23
